package sun.misc;

import java.util.NoSuchElementException;
import java.util.Enumeration;

class CacheEnumerator implements Enumeration
{
    boolean keys;
    int index;
    CacheEntry[] table;
    CacheEntry entry;
    
    CacheEnumerator(CacheEntry[] table, boolean keys) {
        this.table = table;
        this.keys = keys;
        this.index = table.length;
    }
    
    @Override
    public boolean hasMoreElements() {
        while (this.index >= 0) {
            while (this.entry != null) {
                if (this.entry.check() != null) {
                    return true;
                }
                this.entry = this.entry.next;
            }
            while (true) {
                int index = this.index - 1;
                this.index = index;
                if (index >= 0 && (this.entry = this.table[this.index]) == null) {
                    continue;
                }
                break;
            }
        }
        return false;
    }
    
    @Override
    public Object nextElement() {
        while (this.index >= 0) {
            if (this.entry == null) {
                while (true) {
                    int index = this.index - 1;
                    this.index = index;
                    if (index >= 0 && (this.entry = this.table[this.index]) == null) {
                        continue;
                    }
                    break;
                }
            }
            if (this.entry == null) {
                continue;
            }
            CacheEntry entry = this.entry;
            this.entry = entry.next;
            if (entry.check() != null) {
                return this.keys ? entry.key : entry.check();
            }
            continue;
        }
        throw new NoSuchElementException("CacheEnumerator");
    }
}
